diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/video/cyberfb.c ./drivers/video/cyberfb.c
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/video/cyberfb.c	Sun Mar 28 17:54:33 1999
+++ ./drivers/video/cyberfb.c	Sat May 15 11:35:43 1999
@@ -905,7 +905,7 @@
 	cyberfb_get_fix(&fix, con, info);
 	if (con == -1)
 		con = 0;
-	display->screen_base = (unsigned char *)CyberMem;
+	display->screen_base = (char*) CyberMem;
 	display->visual = fix.visual;
 	display->type = fix.type;
 	display->type_aux = fix.type_aux;
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/fs/Config.in ./fs/Config.in
--- /home/jskov/kernel/dist/linux-2.2.8/fs/Config.in	Thu Jan 21 12:10:37 1999
+++ ./fs/Config.in	Fri Feb  5 21:36:32 1999
@@ -135,9 +135,13 @@
     if [ "$CONFIG_PREP" = "y" -o "$CONFIG_CHRP" = "y" ]; then
       define_bool CONFIG_MSDOS_PARTITION y
     fi
+    if [ "$CONFIG_APUS" = "y" ]; then
+      define_bool CONFIG_AMIGA_PARTITION y
+    fi
   else
     define_bool CONFIG_MAC_PARTITION y
     define_bool CONFIG_MSDOS_PARTITION y
+    define_bool CONFIG_AMIGA_PARTITION y
   fi
 fi
 bool 'Support for foreign partition tables' CONFIG_FOREIGN_PARTITIONS
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-m68k/ide.h ./include/asm-m68k/ide.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-m68k/ide.h	Fri Apr 23 17:28:02 1999
+++ ./include/asm-m68k/ide.h	Sat May 15 20:34:06 1999
@@ -177,7 +177,7 @@
 #endif
 #endif
 
-
+#ifndef CONFIG_APUS
 #define insl(data_reg, buffer, wcount) insw(data_reg, buffer, (wcount)<<1)
 #define outsl(data_reg, buffer, wcount) outsw(data_reg, buffer, (wcount)<<1)
 
@@ -377,6 +377,7 @@
 		: "d0", "a0", "a1", "d6")
 
 #endif /* CONFIG_ATARI */
+#endif /* CONFIG_APUS */
 
 #define T_CHAR          (0x0000)        /* char:  don't touch  */
 #define T_SHORT         (0x4000)        /* short: 12 -> 21     */
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-m68k/traps.h ./include/asm-m68k/traps.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-m68k/traps.h	Mon Jan 11 14:20:40 1999
+++ ./include/asm-m68k/traps.h	Sun May 16 10:14:46 1999
@@ -13,6 +13,8 @@
 
 #ifndef __ASSEMBLY__
 
+#include <asm/ptrace.h>
+
 typedef void (*e_vector)(void);
 
 extern e_vector vectors[];
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/amigahw.h ./include/asm-ppc/amigahw.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/amigahw.h	Fri Aug  7 15:56:15 1998
+++ ./include/asm-ppc/amigahw.h	Sun Nov 22 12:57:55 1998
@@ -1 +1,339 @@
-#include <asm-m68k/amigahw.h>
+/*
+** asm-m68k/amigahw.h -- This header defines some macros and pointers for
+**                    the various Amiga custom hardware registers.
+**                    The naming conventions used here conform to those
+**                    used in the Amiga Hardware Reference Manual, 3rd Edition
+**
+** Copyright 1992 by Greg Harp
+**
+** This file is subject to the terms and conditions of the GNU General Public
+** License.  See the file COPYING in the main directory of this archive
+** for more details.
+**
+** Created: 9/24/92 by Greg Harp
+*/
+
+#ifndef _M68K_AMIGAHW_H
+#define _M68K_AMIGAHW_H
+
+    /*
+     *  Different Amiga models
+     */
+
+extern unsigned long amiga_model;
+
+#define AMI_UNKNOWN	(0)
+#define AMI_500		(1)
+#define AMI_500PLUS	(2)
+#define AMI_600		(3)
+#define AMI_1000	(4)
+#define AMI_1200	(5)
+#define AMI_2000	(6)
+#define AMI_2500	(7)
+#define AMI_3000	(8)
+#define AMI_3000T	(9)
+#define AMI_3000PLUS	(10)
+#define AMI_4000	(11)
+#define AMI_4000T	(12)
+#define AMI_CDTV	(13)
+#define AMI_CD32	(14)
+#define AMI_DRACO	(15)
+
+
+    /*
+     *  Chipsets
+     */
+
+extern unsigned long amiga_chipset;
+
+#define CS_STONEAGE	(0)
+#define CS_OCS		(1)
+#define CS_ECS		(2)
+#define CS_AGA		(3)
+
+
+    /*
+     *  Miscellaneous
+     */
+
+extern unsigned long amiga_eclock;	/* 700 kHz E Peripheral Clock */
+extern unsigned long amiga_masterclock;	/* 28 MHz Master Clock */
+extern unsigned long amiga_colorclock;	/* 3.5 MHz Color Clock */
+extern unsigned long amiga_chip_size;	/* Chip RAM Size (bytes) */
+extern unsigned char amiga_vblank;	/* VBLANK Frequency */
+extern unsigned char amiga_psfreq;	/* Power Supply Frequency */
+
+
+#define AMIGAHW_DECLARE(name)	unsigned name : 1
+#define AMIGAHW_SET(name)	(amiga_hw_present.name = 1)
+#define AMIGAHW_PRESENT(name)	(amiga_hw_present.name)
+
+struct amiga_hw_present {
+    /* video hardware */
+    AMIGAHW_DECLARE(AMI_VIDEO);		/* Amiga Video */
+    AMIGAHW_DECLARE(AMI_BLITTER);	/* Amiga Blitter */
+    AMIGAHW_DECLARE(AMBER_FF);		/* Amber Flicker Fixer */
+    /* sound hardware */
+    AMIGAHW_DECLARE(AMI_AUDIO);		/* Amiga Audio */
+    /* disk storage interfaces */
+    AMIGAHW_DECLARE(AMI_FLOPPY);	/* Amiga Floppy */
+    AMIGAHW_DECLARE(A3000_SCSI);	/* SCSI (wd33c93, A3000 alike) */
+    AMIGAHW_DECLARE(A4000_SCSI);	/* SCSI (ncr53c710, A4000T alike) */
+    AMIGAHW_DECLARE(A1200_IDE);		/* IDE (A1200 alike) */
+    AMIGAHW_DECLARE(A4000_IDE);		/* IDE (A4000 alike) */
+    AMIGAHW_DECLARE(CD_ROM);		/* CD ROM drive */
+    /* other I/O hardware */
+    AMIGAHW_DECLARE(AMI_KEYBOARD);	/* Amiga Keyboard */
+    AMIGAHW_DECLARE(AMI_MOUSE);		/* Amiga Mouse */
+    AMIGAHW_DECLARE(AMI_SERIAL);	/* Amiga Serial */
+    AMIGAHW_DECLARE(AMI_PARALLEL);	/* Amiga Parallel */
+    /* real time clocks */
+    AMIGAHW_DECLARE(A2000_CLK);		/* Hardware Clock (A2000 alike) */
+    AMIGAHW_DECLARE(A3000_CLK);		/* Hardware Clock (A3000 alike) */
+    /* supporting hardware */
+    AMIGAHW_DECLARE(CHIP_RAM);		/* Chip RAM */
+    AMIGAHW_DECLARE(PAULA);		/* Paula (8364) */
+    AMIGAHW_DECLARE(DENISE);		/* Denise (8362) */
+    AMIGAHW_DECLARE(DENISE_HR);		/* Denise (8373) */
+    AMIGAHW_DECLARE(LISA);		/* Lisa (8375) */
+    AMIGAHW_DECLARE(AGNUS_PAL);		/* Normal/Fat PAL Agnus (8367/8371) */
+    AMIGAHW_DECLARE(AGNUS_NTSC);	/* Normal/Fat NTSC Agnus (8361/8370) */
+    AMIGAHW_DECLARE(AGNUS_HR_PAL);	/* Fat Hires PAL Agnus (8372) */
+    AMIGAHW_DECLARE(AGNUS_HR_NTSC);	/* Fat Hires NTSC Agnus (8372) */
+    AMIGAHW_DECLARE(ALICE_PAL);		/* PAL Alice (8374) */
+    AMIGAHW_DECLARE(ALICE_NTSC);	/* NTSC Alice (8374) */
+    AMIGAHW_DECLARE(MAGIC_REKICK);	/* A3000 Magic Hard Rekick */
+    AMIGAHW_DECLARE(PCMCIA);		/* PCMCIA Slot */
+    AMIGAHW_DECLARE(ZORRO);		/* Zorro AutoConfig */
+    AMIGAHW_DECLARE(ZORRO3);		/* Zorro III */
+};
+
+extern struct amiga_hw_present amiga_hw_present;
+
+struct CUSTOM {
+    unsigned short bltddat;
+    unsigned short dmaconr;
+    unsigned short vposr;
+    unsigned short vhposr;
+    unsigned short dskdatr;
+    unsigned short joy0dat;
+    unsigned short joy1dat;
+    unsigned short clxdat;
+    unsigned short adkconr;
+    unsigned short pot0dat;
+    unsigned short pot1dat;
+    unsigned short potgor;
+    unsigned short serdatr;
+    unsigned short dskbytr;
+    unsigned short intenar;
+    unsigned short intreqr;
+    unsigned char  *dskptr;
+    unsigned short dsklen;
+    unsigned short dskdat;
+    unsigned short refptr;
+    unsigned short vposw;
+    unsigned short vhposw;
+    unsigned short copcon;
+    unsigned short serdat;
+    unsigned short serper;
+    unsigned short potgo;
+    unsigned short joytest;
+    unsigned short strequ;
+    unsigned short strvbl;
+    unsigned short strhor;
+    unsigned short strlong;
+    unsigned short bltcon0;
+    unsigned short bltcon1;
+    unsigned short bltafwm;
+    unsigned short bltalwm;
+    unsigned char  *bltcpt;
+    unsigned char  *bltbpt;
+    unsigned char  *bltapt;
+    unsigned char  *bltdpt;
+    unsigned short bltsize;
+    unsigned char  pad2d;
+    unsigned char  bltcon0l;
+    unsigned short bltsizv;
+    unsigned short bltsizh;
+    unsigned short bltcmod;
+    unsigned short bltbmod;
+    unsigned short bltamod;
+    unsigned short bltdmod;
+    unsigned short spare2[4];
+    unsigned short bltcdat;
+    unsigned short bltbdat;
+    unsigned short bltadat;
+    unsigned short spare3[3];
+    unsigned short deniseid;
+    unsigned short dsksync;
+    unsigned short *cop1lc;
+    unsigned short *cop2lc;
+    unsigned short copjmp1;
+    unsigned short copjmp2;
+    unsigned short copins;
+    unsigned short diwstrt;
+    unsigned short diwstop;
+    unsigned short ddfstrt;
+    unsigned short ddfstop;
+    unsigned short dmacon;
+    unsigned short clxcon;
+    unsigned short intena;
+    unsigned short intreq;
+    unsigned short adkcon;
+    struct {
+	unsigned short	*audlc;
+	unsigned short audlen;
+	unsigned short audper;
+	unsigned short audvol;
+	unsigned short auddat;
+	unsigned short audspare[2];
+    } aud[4];
+    unsigned char  *bplpt[8];
+    unsigned short bplcon0;
+    unsigned short bplcon1;
+    unsigned short bplcon2;
+    unsigned short bplcon3;
+    unsigned short bpl1mod;
+    unsigned short bpl2mod;
+    unsigned short bplcon4;
+    unsigned short clxcon2;
+    unsigned short bpldat[8];
+    unsigned char  *sprpt[8];
+    struct {
+	unsigned short pos;
+	unsigned short ctl;
+	unsigned short dataa;
+	unsigned short datab;
+    } spr[8];
+    unsigned short color[32];
+    unsigned short htotal;
+    unsigned short hsstop;
+    unsigned short hbstrt;
+    unsigned short hbstop;
+    unsigned short vtotal;
+    unsigned short vsstop;
+    unsigned short vbstrt;
+    unsigned short vbstop;
+    unsigned short sprhstrt;
+    unsigned short sprhstop;
+    unsigned short bplhstrt;
+    unsigned short bplhstop;
+    unsigned short hhposw;
+    unsigned short hhposr;
+    unsigned short beamcon0;
+    unsigned short hsstrt;
+    unsigned short vsstrt;
+    unsigned short hcenter;
+    unsigned short diwhigh;
+    unsigned short spare4[11];
+    unsigned short fmode;
+};
+
+/*
+ * DMA register bits
+ */
+#define DMAF_SETCLR		(0x8000)
+#define DMAF_AUD0		(0x0001)
+#define DMAF_AUD1		(0x0002)
+#define DMAF_AUD2		(0x0004)
+#define DMAF_AUD3		(0x0008)
+#define DMAF_DISK		(0x0010)
+#define DMAF_SPRITE		(0x0020)
+#define DMAF_BLITTER		(0x0040)
+#define DMAF_COPPER		(0x0080)
+#define DMAF_RASTER		(0x0100)
+#define DMAF_MASTER		(0x0200)
+#define DMAF_BLITHOG		(0x0400)
+#define DMAF_BLTNZERO		(0x2000)
+#define DMAF_BLTDONE		(0x4000)
+#define DMAF_ALL		(0x01FF)
+
+struct CIA {
+    unsigned char pra; 		char pad0[0xff];
+    unsigned char prb; 		char pad1[0xff];
+    unsigned char ddra;		char pad2[0xff];
+    unsigned char ddrb;		char pad3[0xff];
+    unsigned char talo;		char pad4[0xff];
+    unsigned char tahi;		char pad5[0xff];
+    unsigned char tblo;		char pad6[0xff];
+    unsigned char tbhi;		char pad7[0xff];
+    unsigned char todlo;	char pad8[0xff];
+    unsigned char todmid;	char pad9[0xff];
+    unsigned char todhi;	char pada[0x1ff];
+    unsigned char sdr; 		char padb[0xff];
+    unsigned char icr; 		char padc[0xff];
+    unsigned char cra; 		char padd[0xff];
+    unsigned char crb; 		char pade[0xff];
+};
+
+#define zTwoBase (0x80000000)
+#define ZTWO_PADDR(x) (((unsigned long)(x))-zTwoBase)
+#define ZTWO_VADDR(x) (((unsigned long)(x))+zTwoBase)
+
+#define CUSTOM_PHYSADDR     (0xdff000)
+#define custom ((*(volatile struct CUSTOM *)(zTwoBase+CUSTOM_PHYSADDR)))
+
+#define CIAA_PHYSADDR	  (0xbfe001)
+#define CIAB_PHYSADDR	  (0xbfd000)
+#define ciaa   ((*(volatile struct CIA *)(zTwoBase + CIAA_PHYSADDR)))
+#define ciab   ((*(volatile struct CIA *)(zTwoBase + CIAB_PHYSADDR)))
+
+#ifdef CONFIG_APUS_CHIP_EXCEPT
+#define CHIP_PHYSADDR	    (0x004000)
+#else
+#define CHIP_PHYSADDR	    (0x000000)
+#endif
+#define chipaddr ((unsigned long)(zTwoBase + CHIP_PHYSADDR))
+void amiga_chip_init (void);
+void *amiga_chip_alloc (long size);
+void amiga_chip_free (void *);
+unsigned long amiga_chip_avail( void ); /*MILAN*/
+
+struct tod3000 {
+  unsigned int  :28, second2:4;	/* lower digit */
+  unsigned int  :28, second1:4;	/* upper digit */
+  unsigned int  :28, minute2:4;	/* lower digit */
+  unsigned int  :28, minute1:4;	/* upper digit */
+  unsigned int  :28, hour2:4;	/* lower digit */
+  unsigned int  :28, hour1:4;	/* upper digit */
+  unsigned int  :28, weekday:4;
+  unsigned int  :28, day2:4;	/* lower digit */
+  unsigned int  :28, day1:4;	/* upper digit */
+  unsigned int  :28, month2:4;	/* lower digit */
+  unsigned int  :28, month1:4;	/* upper digit */
+  unsigned int  :28, year2:4;	/* lower digit */
+  unsigned int  :28, year1:4;	/* upper digit */
+  unsigned int  :28, cntrl1:4;	/* control-byte 1 */
+  unsigned int  :28, cntrl2:4;	/* control-byte 2 */  
+  unsigned int  :28, cntrl3:4;	/* control-byte 3 */
+};
+#define TOD3000_CNTRL1_HOLD	0
+#define TOD3000_CNTRL1_FREE	9
+#define TOD_3000 ((struct tod3000 *)(zTwoBase+0xDC0000))
+
+struct tod2000 {
+  unsigned int  :28, second2:4;	/* lower digit */
+  unsigned int  :28, second1:4;	/* upper digit */
+  unsigned int  :28, minute2:4;	/* lower digit */
+  unsigned int  :28, minute1:4;	/* upper digit */
+  unsigned int  :28, hour2:4;	/* lower digit */
+  unsigned int  :28, hour1:4;	/* upper digit */
+  unsigned int  :28, day2:4;	/* lower digit */
+  unsigned int  :28, day1:4;	/* upper digit */
+  unsigned int  :28, month2:4;	/* lower digit */
+  unsigned int  :28, month1:4;	/* upper digit */
+  unsigned int  :28, year2:4;	/* lower digit */
+  unsigned int  :28, year1:4;	/* upper digit */
+  unsigned int  :28, weekday:4;
+  unsigned int  :28, cntrl1:4;	/* control-byte 1 */
+  unsigned int  :28, cntrl2:4;	/* control-byte 2 */  
+  unsigned int  :28, cntrl3:4;	/* control-byte 3 */
+};
+
+#define TOD2000_CNTRL1_HOLD	(1<<0)
+#define TOD2000_CNTRL1_BUSY	(1<<1)
+#define TOD2000_CNTRL3_24HMODE	(1<<2)
+#define TOD2000_HOUR1_PM	(1<<2)
+#define TOD_2000 ((struct tod2000 *)(zTwoBase+0xDC0000))
+
+#endif /* _M68K_AMIGAHW_H */
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/amigappc.h ./include/asm-ppc/amigappc.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/amigappc.h	Mon Jan  4 11:32:04 1999
+++ ./include/asm-ppc/amigappc.h	Sat May 15 19:30:27 1999
@@ -16,30 +16,23 @@
 
 #ifndef __ASSEMBLY__
 
-#ifndef iobarrier_rw /* Don't include io.h - avoid circular dependency */
-#define iobarrier_rw() eieio()
-#endif
+#include <asm/system.h>
 
 #define APUS_WRITE(_a_, _v_)				\
 do {							\
 	(*((volatile unsigned char *)(_a_)) = (_v_));	\
-	iobarrier_rw ();				\
+	mb();						\
 } while (0)
 
-#define APUS_READ(_a_, _v_) 				\
+#define APUS_READ(_a_, _v_)				\
 do {							\
 	(_v_) = (*((volatile unsigned char *)(_a_)));	\
-	iobarrier_rw ();				\
+	mb();						\
 } while (0)
 #endif /* ndef __ASSEMBLY__ */
 
 /* Maybe add a [#ifdef WANT_ZTWOBASE] condition to amigahw.h? */
 #define zTwoBase (0x80000000)
-
-/* At CYBERBASEp we find the following sum:
- * -KERNELBASE+CyberStormMemoryBase
- */
-#define CYBERBASEp (0xfff00000)
 
 #define APUS_IPL_BASE   	(zTwoBase + 0x00f60000)
 #define APUS_REG_RESET    	(APUS_IPL_BASE + 0x00)
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/amigayle.h ./include/asm-ppc/amigayle.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/amigayle.h	Mon Oct  5 22:09:06 1998
+++ ./include/asm-ppc/amigayle.h	Sat May 15 18:53:25 1999
@@ -1 +1 @@
-#include "../asm-m68k/amigayle.h"
+#include <asm-m68k/amigayle.h>
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/amipcmcia.h ./include/asm-ppc/amipcmcia.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/amipcmcia.h	Mon Oct  5 22:09:06 1998
+++ ./include/asm-ppc/amipcmcia.h	Sat May 15 18:53:32 1999
@@ -1 +1 @@
-#include "../asm-m68k/amipcmcia.h"
+#include <asm-m68k/amipcmcia.h>
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/ide.h ./include/asm-ppc/ide.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/ide.h	Tue May 11 11:29:01 1999
+++ ./include/asm-ppc/ide.h	Sun May 16 14:22:59 1999
@@ -145,7 +145,7 @@
 /*
  * The following are not needed for the non-m68k ports
  */
-#define ide_ack_intr(base, irq)		(1)
+#define ide_ack_intr(hwif)	((hwif)->ack_intr ? (hwif)->ack_intr(hwif) : 1)
 #define ide_release_lock(lock)		do {} while (0)
 #define ide_get_lock(lock, hdlr, data)	do {} while (0)
 
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/init.h ./include/asm-ppc/init.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/init.h	Mon Jan  4 15:16:13 1999
+++ ./include/asm-ppc/init.h	Tue Jan  5 20:12:11 1999
@@ -20,6 +20,12 @@
 	__argprep __prep; \
 	__argprep
 
+#define __apus __attribute__ ((__section__ (".text.apus")))
+#define __apusdata __attribute__ ((__section__ (".data.apus")))
+#define __apusfunc(__argapus) \
+	__argapus __apus; \
+	__argapus
+
 /* this is actually just common chrp/pmac code, not OF code -- Cort */
 #define __openfirmware __attribute__ ((__section__ (".text.openfirmware")))
 #define __openfirmwaredata __attribute__ ((__section__ (".data.openfirmware")))
@@ -51,6 +57,10 @@
 #define __prep
 #define __prepdata
 #define __prepfunc(x) x
+
+#define __apus
+#define __apusdata
+#define __apusfunc(x) x
 
 #define __openfirmware
 #define __openfirmwaredata
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/io.h ./include/asm-ppc/io.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/io.h	Tue May 11 11:29:01 1999
+++ ./include/asm-ppc/io.h	Sun May 16 13:37:55 1999
@@ -3,7 +3,9 @@
 
 #include <linux/config.h>
 #include <asm/page.h>
+#include <asm/pgtable.h>
 #include <asm/byteorder.h>
+#include <asm/processor.h>
 
 #define SIO_CONFIG_RA	0x398
 #define SIO_CONFIG_RD	0x399
@@ -24,33 +26,26 @@
 #define _ISA_MEM_BASE   0
 #define PCI_DRAM_OFFSET 0x80000000
 #else /* CONFIG_MBX8xx */
-#ifdef CONFIG_APUS
-#define _IO_BASE 0
-#define _ISA_MEM_BASE 0
-#define PCI_DRAM_OFFSET 0
-#else
 extern unsigned long isa_io_base;
 extern unsigned long isa_mem_base;
 extern unsigned long pci_dram_offset;
 #define _IO_BASE	isa_io_base
 #define _ISA_MEM_BASE	isa_mem_base
 #define PCI_DRAM_OFFSET	pci_dram_offset
-#endif /* CONFIG_APUS */
 #endif /* CONFIG_MBX8xx */
 
 #define readb(addr) in_8((volatile unsigned char *)(addr))
 #define writeb(b,addr) out_8((volatile unsigned char *)(addr), (b))
-#if defined(CONFIG_APUS)
-#define readw(addr) (*(volatile unsigned short *) (addr))
-#define readl(addr) (*(volatile unsigned int *) (addr))
-#define writew(b,addr) ((*(volatile unsigned short *) (addr)) = (b))
-#define writel(b,addr) ((*(volatile unsigned int *) (addr)) = (b))
-#else
-#define readw(addr) in_le16((volatile unsigned short *)(addr))
-#define readl(addr) in_le32((volatile unsigned *)(addr))
-#define writew(b,addr) out_le16((volatile unsigned short *)(addr),(b))
-#define writel(b,addr) out_le32((volatile unsigned *)(addr),(b))
-#endif
+#define readw(addr) ((is_apus) ? (*(volatile unsigned short *) (addr)) : \
+		     in_le16((volatile unsigned short *)(addr)))
+#define readl(addr) ((is_apus) ? (*(volatile unsigned int *) (addr)) :	\
+		     in_le32((volatile unsigned *)addr)) 
+#define writew(b,addr) ((is_apus) ? 					 \
+			((*(volatile unsigned short *) (addr)) = (b)) :	 \
+			out_le16((volatile unsigned short *)(addr),(b)))
+#define writel(b,addr) ((is_apus) ?					\
+			((*(volatile unsigned int *) (addr)) = (b)) :	\
+			out_le32((volatile unsigned *)(addr),(b)))
 
 #define insb(port, buf, ns)	_insb((unsigned char *)((port)+_IO_BASE), (buf), (ns))
 #define outsb(port, buf, ns)	_outsb((unsigned char *)((port)+_IO_BASE), (buf), (ns))
@@ -61,17 +56,18 @@
 
 #define inb(port)		in_8((unsigned char *)((port)+_IO_BASE))
 #define outb(val, port)		out_8((unsigned char *)((port)+_IO_BASE), (val))
-#if defined(CONFIG_APUS)
-#define inw(port)		in_be16((unsigned short *)((port)+_IO_BASE))
-#define outw(val, port)		out_be16((unsigned short *)((port)+_IO_BASE), (val))
-#define inl(port)		in_be32((unsigned *)((port)+_IO_BASE))
-#define outl(val, port)		out_be32((unsigned *)((port)+_IO_BASE), (val))
-#else
-#define inw(port)		in_le16((unsigned short *)((port)+_IO_BASE))
-#define outw(val, port)		out_le16((unsigned short *)((port)+_IO_BASE), (val))
-#define inl(port)		in_le32((unsigned *)((port)+_IO_BASE))
-#define outl(val, port)		out_le32((unsigned *)((port)+_IO_BASE), (val))
-#endif
+#define inw(port) ((is_apus) ?						\
+		   in_be16((unsigned short *)(port)) :			\
+		   in_le16((unsigned short *)((port)+_IO_BASE)))
+#define outw(val, port) ((is_apus) ?					    \
+			 out_be16((unsigned short *)(port), (val)) :	    \
+			 out_le16((unsigned short *)((port)+_IO_BASE), (val)))
+#define inl(port) ((is_apus) ?					\
+		   in_be32((unsigned *)(port)) :		\
+		   in_le32((unsigned *)((port)+_IO_BASE)))
+#define outl(val, port) ((is_apus) ?					 \
+			 out_be32((unsigned *)(port), (val)) :		 \
+			 out_le32((unsigned *)((port)+_IO_BASE), (val)))
 
 #define inb_p(port)		in_8((unsigned char *)((port)+_IO_BASE))
 #define outb_p(val, port)	out_8((unsigned char *)((port)+_IO_BASE), (val))
@@ -105,6 +101,14 @@
 #define memcpy_toio(a,b,c)	memcpy((a),(b),(c))
 
 #ifdef __KERNEL__
+/* These are not used by the PPC ioremap, but prevents
+   compilation errors. */
+/* Values for nocacheflag and cmode */
+#define	IOMAP_FULL_CACHING		0
+#define	IOMAP_NOCACHE_SER		1
+#define	IOMAP_NOCACHE_NONSER		2
+#define	IOMAP_WRITETHROUGH		3
+
 /*
  * Map in an area of physical address space, for accessing
  * I/O devices etc.
@@ -113,20 +117,11 @@
 		       unsigned long flags);
 extern void *ioremap(unsigned long address, unsigned long size);
 #define ioremap_nocache(addr, size)	ioremap((addr), (size))
+#define ioremap_writethrough(addr, size) \
+        __ioremap((addr), (size), _PAGE_WRITETHRU)
 extern void iounmap(void *addr);
 extern unsigned long iopa(unsigned long addr);
-#ifdef CONFIG_APUS
 extern unsigned long mm_ptov(unsigned long addr) __attribute__ ((const));
-#endif
-
-/* Values for nocacheflag and cmode */
-/* These are not used by the APUS kernel_map, but prevents
-   compilation errors. */
-#define	IOMAP_FULL_CACHING		0
-#define	IOMAP_NOCACHE_SER		1
-#define	IOMAP_NOCACHE_NONSER		2
-#define	IOMAP_WRITETHROUGH		3
-
 
 /*
  * The PCI bus is inherently Little-Endian.  The PowerPC is being
@@ -137,24 +132,22 @@
  */
 extern inline unsigned long virt_to_bus(volatile void * address)
 {
-#ifndef CONFIG_APUS
+	if (is_apus)
+		return iopa ((unsigned long) address);
+
         if (address == (void *)0)
 		return 0;
         return (unsigned long)address - KERNELBASE + PCI_DRAM_OFFSET;
-#else
-	return iopa ((unsigned long) address);
-#endif
 }
 
 extern inline void * bus_to_virt(unsigned long address)
 {
-#ifndef CONFIG_APUS
+	if (is_apus)
+		return (void*) mm_ptov (address);
+
         if (address == 0)
 		return 0;
         return (void *)(address - PCI_DRAM_OFFSET + KERNELBASE);
-#else
-	return (void*) mm_ptov (address);
-#endif
 }
 
 /*
@@ -163,20 +156,18 @@
  */
 extern inline unsigned long virt_to_phys(volatile void * address)
 {
-#ifndef CONFIG_APUS
+	if (is_apus)
+		return iopa ((unsigned long) address);
+
 	return (unsigned long) address - KERNELBASE;
-#else
-	return iopa ((unsigned long) address);
-#endif
 }
 
 extern inline void * phys_to_virt(unsigned long address)
 {
-#ifndef CONFIG_APUS
+	if (is_apus)
+		return (void*) mm_ptov (address);
+
 	return (void *) (address + KERNELBASE);
-#else
-	return (void*) mm_ptov (address);
-#endif
 }
 
 #endif /* __KERNEL__ */
@@ -190,13 +181,6 @@
 {
 	__asm__ __volatile__ ("eieio" : : : "memory");
 }
-
-/* Enforce in-order execution of data I/O. 
- * No distinction between read/write on PPC; use eieio for all three.
- */
-#define iobarrier_rw() eieio()
-#define iobarrier_r()  eieio()
-#define iobarrier_w()  eieio()
 
 /*
  * 8, 16 and 32 bit, big and little endian I/O operations, with barrier.
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/keyboard.h ./include/asm-ppc/keyboard.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/keyboard.h	Tue May 11 11:29:02 1999
+++ ./include/asm-ppc/keyboard.h	Sun May 16 11:31:09 1999
@@ -18,9 +18,6 @@
 #include <linux/config.h>
 #include <asm/adb.h>
 #include <asm/machdep.h>
-#ifdef CONFIG_APUS
-#include <asm-m68k/keyboard.h>
-#else
 
 #define KEYBOARD_IRQ			1
 #define DISABLE_KBD_DURING_INTERRUPTS	0
@@ -30,28 +27,28 @@
 {
 	return ppc_md.kbd_setkeycode(scancode, keycode);
 }
-
-static inline int kbd_getkeycode(unsigned int x)
+  
+static inline int kbd_getkeycode(unsigned int scancode)
 {
 	return ppc_md.kbd_getkeycode(scancode);
 }
-
+  
 static inline int kbd_translate(unsigned char keycode, unsigned char *keycodep,
-		     char raw_mode)
+				char raw_mode)
 {
 	return ppc_md.kbd_translate(keycode, keycodep, raw_mode);
 }
-
+  
 static inline int kbd_unexpected_up(unsigned char keycode)
 {
 	return ppc_md.kbd_unexpected_up(keycode);
 }
-
+  
 static inline void kbd_leds(unsigned char leds)
 {
 	ppc_md.kbd_leds(leds);
 }
-
+  
 static inline void kbd_init_hw(void)
 {
 	ppc_md.kbd_init_hw();
@@ -64,8 +61,6 @@
 #else
 # define SYSRQ_KEY 0x54
 #endif
-
-#endif /* CONFIG_APUS */
 
 #endif /* __KERNEL__ */
 
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/linux_logo.h ./include/asm-ppc/linux_logo.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/linux_logo.h	Mon Oct  5 22:09:10 1998
+++ ./include/asm-ppc/linux_logo.h	Tue Jan  5 21:53:17 1999
@@ -12,14 +12,6 @@
  */
  
 #include <linux/config.h>
-#ifdef CONFIG_APUS
-#include <asm-m68k/linux_logo.h>
-
-#undef linux_logo_banner
-#define linux_logo_banner "Linux/PPC version " UTS_RELEASE
-
-#else
-
 #include <linux/init.h>
 
 #define linux_logo_banner "Linux/PPC version " UTS_RELEASE
@@ -48,4 +40,3 @@
 extern unsigned char linux_logo16[];
 
 #endif
-#endif /* CONFIG_APUS */
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/m68kserial.h ./include/asm-ppc/m68kserial.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/m68kserial.h	Thu Jan  1 01:00:00 1970
+++ ./include/asm-ppc/m68kserial.h	Sun May 16 11:55:59 1999
@@ -0,0 +1 @@
+#include <asm-m68k/m68kserial.h>
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/page.h ./include/asm-ppc/page.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/page.h	Tue May 11 11:29:03 1999
+++ ./include/asm-ppc/page.h	Sat May 15 11:35:57 1999
@@ -67,15 +67,34 @@
 #define copy_page(to,from)	memcpy((void *)(to), (void *)(from), PAGE_SIZE)
 
 /* map phys->virtual and virtual->phys for RAM pages */
-#ifdef CONFIG_APUS
-#include <asm/amigappc.h>
-/* Word at CYBERBASEp has the value (-KERNELBASE+CYBERBASE). */
-#define __pa(x)			((unsigned long)(x)+(*(unsigned long*)CYBERBASEp))
-#define __va(x)			((void *)((unsigned long)(x)-(*(unsigned long*)CYBERBASEp)))
-#else
-#define __pa(x)			((unsigned long)(x)-PAGE_OFFSET)
-#define __va(x)			((void *)((unsigned long)(x)+PAGE_OFFSET))
-#endif
+static inline unsigned long ___pa(unsigned long v)
+{ 
+	unsigned long p;
+	asm volatile ("1: addis %0, %1, %2;" 
+		      ".section \".vtop_fixup\",\"aw\";"
+		      ".align  1;"
+		      ".long   1b;"
+		      ".previous;"
+		      : "=r" (p) 
+		      : "b" (v), "K" (((-PAGE_OFFSET) >> 16) & 0xffff));
+
+	return p;
+}
+static inline void* ___va(unsigned long p)
+{ 
+	unsigned long v;
+	asm volatile ("1: addis %0, %1, %2;" 
+		      ".section \".ptov_fixup\",\"aw\";"
+		      ".align  1;"
+		      ".long   1b;"
+		      ".previous;"
+		      : "=r" (v) 
+		      : "b" (p), "K" (((PAGE_OFFSET) >> 16) & 0xffff));
+
+	return (void*) v;
+}
+#define __pa(x) ___pa ((unsigned long)(x))
+#define __va(x) ___va ((unsigned long)(x))
 
 #define MAP_NR(addr)		(((unsigned long)addr-PAGE_OFFSET) >> PAGE_SHIFT)
 #define MAP_PAGE_RESERVED	(1<<15)
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/pgtable.h ./include/asm-ppc/pgtable.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/pgtable.h	Tue May 11 11:29:03 1999
+++ ./include/asm-ppc/pgtable.h	Sun May 16 13:37:55 1999
@@ -610,7 +611,6 @@
 #define module_map      vmalloc
 #define module_unmap    vfree
 
-/* CONFIG_APUS */
 /* For virtual address to physical address conversion */
 extern void cache_clear(__u32 addr, int length);
 extern void cache_push(__u32 addr, int length);
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/processor.h ./include/asm-ppc/processor.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/processor.h	Wed May 12 09:57:47 1999
+++ ./include/asm-ppc/processor.h	Sat May 15 18:33:35 1999
@@ -24,7 +24,7 @@
 #define MSR_RI		(1<<1)		/* Recoverable Exception */
 #define MSR_LE		(1<<0)		/* Little-Endian enable */
 
-#ifdef CONFIG_APUS
+#ifdef CONFIG_APUS_FAST_EXCEPT
 #define MSR_		MSR_ME|MSR_IP|MSR_RI
 #else
 #define MSR_		MSR_ME|MSR_RI
@@ -181,6 +181,7 @@
 extern int have_of;
 extern int is_prep;
 extern int is_chrp;
+extern int is_apus;
 extern int is_powerplus;
 
 /* what kind of prep workstation we are */
@@ -288,5 +289,4 @@
 
 #endif /* ndef ASSEMBLY*/
 
-  
 #endif /* __ASM_PPC_PROCESSOR_H */
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/serial.h ./include/asm-ppc/serial.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/serial.h	Fri Aug  7 15:56:22 1998
+++ ./include/asm-ppc/serial.h	Sat May 15 18:52:39 1999
@@ -4,10 +4,6 @@
 
 #include <linux/config.h>
 
-#ifdef CONFIG_APUS
-#include <asm-m68k/serial.h>
-#else
-
 /*
  * This assumes you have a 1.8432 MHz clock for your UART.
  *
@@ -119,5 +115,3 @@
 	EXTRA_SERIAL_PORT_DEFNS		\
 	HUB6_SERIAL_PORT_DFNS		\
 	MCA_SERIAL_PORT_DFNS
-
-#endif /* CONFIG_APUS */
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/system.h ./include/asm-ppc/system.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/asm-ppc/system.h	Wed May 12 09:57:49 1999
+++ ./include/asm-ppc/system.h	Sat May 15 18:35:15 1999
@@ -39,6 +39,14 @@
 	asm("dcbf %0,%1; sync" : : "r" (line), "r" (0));
 }
 
+extern __inline__ void dcbi(void *line)
+{
+	asm("dcbi %0,%1\n\t"
+	    "sync \n\t"
+	    "isync \n\t"
+	    :: "r" (line), "r" (0));
+}
+
 extern __inline__ void __restore_flags(unsigned long flags)
 {
         extern atomic_t ppc_n_lost_interrupts;
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/include/linux/socket.h ./include/linux/socket.h
--- /home/jskov/kernel/dist/linux-2.2.8/include/linux/socket.h	Thu Apr 22 15:01:41 1999
+++ ./include/linux/socket.h	Sat May 15 18:27:25 1999
@@ -1,7 +1,7 @@
 #ifndef _LINUX_SOCKET_H
 #define _LINUX_SOCKET_H
 
-#if defined(__KERNEL__) || !defined(__GLIBC__) || (__GLIBC__ < 2)
+#if defined(__KERNEL__) || !defined(__GLIBC__) || (__GLIBC__ < 2) || (defined(__powerpc__) && __GLIBC__ == 2 && __GLIBC_MINOR__ == 0)
 
 #include <asm/socket.h>			/* arch-dependent defines	*/
 #include <linux/sockios.h>		/* the SIOCxxx I/O controls	*/
